(ns wanijo.framework.view
  (:require [hiccup.page :refer
             [html5 include-css]]
            [wanijo.framework.routing :refer [path]]))

(defn btnlink
  ([target caption]
   (btnlink target caption ""))
  ([target caption class]
   [:a {:href target}
    [:button {:class class}
     caption]]))

(defn layout!
  [& {:keys [content title session]
      :or {content []
           title nil
           session {}}}]
  (let [ident (:ident session)
        authed? (some? ident)
        devmode? (:devmode session)]
    (html5
     [:head
      [:meta {:charset "utf-8"}]
      [:meta {:name "viewport"
              :content "width=device-width,initial-scale=1,shrink-to-fit=no"}]
      [:title (str "wan ijo" (when title (str " - " title)))]
      (include-css "/css/app.css")
      (when devmode? (include-css "/css/devmode.css"))]
     [:body
      [:section.grid
       [:header
        [:h1.app-title "wan ijo"
         (when authed?
           [:small.app-title__hello
            (str "O, " ident)])]
        (when authed?
          [:section.header-content
           (btnlink (path :schema-overview)
                    "Jaki ijo"
                    "header-content__link")
           (btnlink (path :auth-logout)
                    "Lape!"
                    "header-content__link")])]
       [:nav (when authed? "nav")]
       (vec (concat [:main] content))
       [:aside (when authed? "aside")]
       [:footer
        [:small "Ilo pali e ijo"]]]])))

(defn flash-error [content]
  [:section.flash--error
   [:h2.flash__heading--error "Pakala"]
   content])
